#pragma once

#include<stddef.h>
#include<string.h>

/* Stable sorting algorithm */

static inline void ssort(void *base, size_t nmemb, size_t size, intmax_t(*compar)(const void*, const void*)) {
	void *tmp = alloca(size);
	
	intmax_t i = 1;
	while(i < nmemb) {
		memcpy(tmp, base + size * i, size);
		
		intmax_t j = i - 1;
		while(j >= 0 && compar(base + size * j, tmp) > 0) {
			memcpy(base + size * (j + 1), base + size * j, size);
			j--;
		}
		
		memcpy(base + size * (j + 1), tmp, size);
		
		i++;
	}
}
